<?php

namespace Lib;
class Environment {
    private $util;
    public function __construct(\Util\Util $util) {
		$this->util = $util;
	}

    private function setExpired ($key) {
        if (isset($_SESSION) && isset($_SESSION['CREATED'.$key])) {
            $_SESSION['CREATED'.$key] = time();
        }
    }

    private function isExpired ($key) {
        return !isset($_SESSION) || isset($_SESSION) && (isset($_SESSION['CREATED'.$key]) && (time() - $_SESSION['CREATED'.$key] > 1800));
    }

    public function getSessionValue ($key) {
        $return = null;
        try {
            $return = !$this-> isExpired($key) && isset($_SESSION[$key]) ? $_SESSION[$key] : null;
        } catch (\Throwable $th) {
            $this->util->logException($th->getMessage());
        }
        return $return;
    }

    public function setSessionValue ($key, $value) {
        try {
            $this->setExpired($key);
            $_SESSION[$key] = $value;
        } catch (\Throwable $th) {
            $this->util->logException($th->getMessage());
        }
    }
   
    public function unsetSessionValue ($key) {
        try {
            if (isset( $_SESSION[$key])){
                $_SESSION[$key] = null;
            }
        } catch (\Throwable $th) {
            $this->util->logException($th->getMessage());
        }
    }

    public function clearSession (){
        try {
            $_SESSION = array();
        } catch (\Throwable $th) {
            $this->util->logException($th->getMessage());
        }
    }
} 