#!/bin/bash
if [ $(id -u) -ne 0 ]; then
 echo "Para essa instalação precisa de permissão de adminnistrador.
Por favor execute novamente utilizando sudo ou su."
 exit 1
fi

# Get the local IP address
LAN_IP=$(hostname -I | awk '{print $1}')

# Extract the network of the IP address
IFS='.' read -ra IP_PARTS <<< "$LAN_IP"
NETWORK="${IP_PARTS[0]}.${IP_PARTS[1]}.${IP_PARTS[2]}"

SERVER_IP="http://"$NETWORK".100"
SERVER_PORT="9091"

TEKNISA_FRONT_UPDATE_CONTENT_SRC="./TeknisaFrontUpdate.sh"
TEKNISA_FRONT_UPDATE_PATH="/usr/local/bin/"
TEKNISA_FRONT_UPDATE_FILE_PATH="/usr/local/bin/TeknisaFrontUpdate.sh"

TEKNISA_KDS_SERVICE_PATH="/etc/systemd/system/kds-updater.service"

KDS_SHORTCUT_PATH="$HOME/Desktop/KDS-EMBARCADO-AU.DESKTOP"

REBOOT_AT_3AM_CONTENT='#!/bin/bash
sleep 300
# Reboot the system
sudo reboot'

KDS_SHORTCUT_CONTENT="
[Desktop Entry]
Type=Application
Version=1.0
Name=KDS-EMBARCADO-AU
Comment=EMBARCADO AUTO UPDATE APÓS REBOOT DO SISTEMA
Icon=
Exec=/usr/local/kds/KDS
Terminal=false
StartupNotify=false
Categories=Teknisa;
"

KDS_SERVICE_CONTENT="
[Unit]
Description=Service - KDS UPDATER

[Service]
ExecStart=$TEKNISA_FRONT_UPDATE_FILE_PATH
Type=simple

[Install]
WantedBy=multi-user.target
"

#CREATE FILE WITH FRONT AUTO UPDATER
sudo cp "$TEKNISA_FRONT_UPDATE_CONTENT_SRC" "$TEKNISA_FRONT_UPDATE_PATH"
sudo sed -i 's|<>SERVER_IP_PORT<>|'"$SERVER_IP:$SERVER_PORT"'|g' "$TEKNISA_FRONT_UPDATE_FILE_PATH"
sudo chmod +x "$TEKNISA_FRONT_UPDATE_PATH"


if [ -f /etc/rc.local ]; then
  echo "setting initialization command on /etc/rc.local"
  #SET FRONT AUTO UPDATER TO RUN ON BOOT
  if ! grep -q "sudo '$TEKNISA_FRONT_UPDATE_FILE_PATH' &" /etc/rc.local; then
      sudo sed -i "/^exit 0/i sudo '$TEKNISA_FRONT_UPDATE_FILE_PATH' &" /etc/rc.local
  fi
else
  echo "creating a service for inicialization"
  if [ ! -f "$TEKNISA_KDS_SERVICE_PATH" ]; then
    sudo touch "$TEKNISA_KDS_SERVICE_PATH"
  fi
  sudo echo -e "$KDS_SERVICE_CONTENT" > "$TEKNISA_KDS_SERVICE_PATH"
  sudo systemctl daemon-reload
  sudo systemctl start kds-updater.service
  sudo systemctl enable kds-updater.service
fi

sudo echo -e "$REBOOT_AT_3AM_CONTENT" > "$REBOOT_AT_3AM_PATH"
sudo chmod +x "$REBOOT_AT_3AM_PATH"

#SET FRONT AUTO REBOOTER TO RUN ON BOOT
if ! crontab -l | grep -q "$REBOOT_AT_3AM_PATH"; then
  (crontab -l ; echo "0 3 * * * '$REBOOT_AT_3AM_PATH'") | crontab -
fi

if [ ! -f "$KDS_SHORTCUT_PATH" ]; then
  sudo touch "$KDS_SHORTCUT_PATH"
fi

sudo echo -e "$KDS_SHORTCUT_CONTENT" > "$KDS_SHORTCUT_PATH"
sudo chmod +x $KDS_SHORTCUT_PATH
